#if defined(WIN32)
#  include "glut.h"
#  include "glext.h"
extern PFNGLMULTITEXCOORD2DVPROC glMultiTexCoord2dv;
extern PFNGLMULTITEXCOORD3DPROC glMultiTexCoord3d;
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

#include "rectangle.h"
#include "matrix.h"

/*
** 
*/
void rectangle(double w, double h, const float l[])
{
  /* ĺκɸ */
  const GLdouble vertex[4][3] = {
    { -w, -h, 0.0 },
    {  w, -h, 0.0 },
    {  w,  h, 0.0 },
    { -w,  h, 0.0 }
  };
  
  /* ĺΥƥɸ */
  static const GLdouble texcoord[4][2] = {
    { 0.0, 0.0 }, { 1.0, 0.0 }, { 1.0, 1.0 }, { 0.0, 1.0 }
  };
  
  /* ܶ֡ʡɸϡˤˤ */
  double lt[4] = { l[0], l[1], l[2], l[3] };
  /* ǥӥ塼Ѵεչ */
  double m[16];
  
  /* ߤΥǥӥ塼Ѵεչ */
  glGetDoublev(GL_MODELVIEW_MATRIX, m);
  inverse(m, m);

  /* ܶ֡ʡɸϡˤˤ֤ */
  transform(lt, m, lt);

  /* ʿԸǤʤмºɸƤ */
  if (lt[3] != 0.0) {
    lt[0] /= lt[3];
    lt[1] /= lt[3];
    lt[2] /= lt[3];
  }
  
  /*  */
  glBegin(GL_QUADS);
  
  for (int i = 0; i < 4; ++i) {
    /* ˡޥåפΥƥɸꤹ */
    glTexCoord2dv(texcoord[i]);
    glMultiTexCoord2dv(GL_TEXTURE2, texcoord[i]);
    
    /* ֤ܶˤ٥ȥ
       ޥåפΥƥɸꤹ */
    if (lt[3] != 0.0) {
      glMultiTexCoord3d(GL_TEXTURE1,
        lt[0] - vertex[i][0],
        lt[1] - vertex[i][1],
        lt[2] - vertex[i][2]);
    }
    else {
      glMultiTexCoord3d(GL_TEXTURE1, lt[0], lt[1], lt[2]);
    }
    
    /* бĺɸλ */
    glVertex3dv(vertex[i]);
  }
  glEnd();
}
